/**********************************************************************
 * ISO MPEG Audio Subgroup Software Simulation Group (1996)
 * ISO 13818-3 MPEG-2 Audio Encoder - Lower Sampling Frequency Extension
 *
 * $Id: common.h,v 1.1.1.1 1999/12/05 21:15:48 afaber Exp $
 *
 * $Log: common.h,v $
 * Revision 1.1.1.1  1999/12/05 21:15:48  afaber
 * no message
 *
 * Revision 1.1  1996/02/14 04:04:23  rowlands
 * Initial revision
 *
 * Received from Mike Coleman
 **********************************************************************/

#ifndef COMMON_DOT_H
#define COMMON_DOT_H

#include "types.h"
#include "MPegError.h"
#include "BladeDLL.h"


/* MS_DOS and VMS do not define TABLES_PATH, so OpenTableFile will default
   to finding the data files in the default directory */

/***********************************************************************
*
*  Global Include Files
*
***********************************************************************/

#include        <stdio.h>
#include        <string.h>
#include        <math.h>
//#include        <unistd.h>




/***********************************************************************
*
*  Global Variable External Declarations
*
***********************************************************************/

extern char*	mode_names[4];
extern char*	layer_names[3];
extern char*	version_names[2];
extern double   s_freq[2][4];
extern int      bitrate[2][3][15];
extern double	multiple[64];


/***********************************************************************
*
*  Global Function Prototype Declarations
*
***********************************************************************/


int		js_bound(int lay,int m_ext);

void	hdr_to_frps(frame_params* fr_ps);

void	WriteHdr(frame_params *fr_ps,FILE *s);

void	WriteBitAlloc(UINT bit_alloc[2][SBLIMIT],frame_params *f_p,FILE *s);

void	WriteScale(	UINT bit_alloc[2][SBLIMIT],
					UINT scfsi[2][SBLIMIT],
					UINT scalar[2][3][SBLIMIT],
					frame_params* fr_ps,
					FILE*	s);

void	WriteSamples(	int ch,
						UINT sample[SBLIMIT],
						UINT bit_alloc[SBLIMIT],
						frame_params* fr_ps,
						FILE *s	);	


int		NumericQ(char *s);

int		SmpFrqIndex(LONG sRate,INT* version);

void*	mem_alloc(ULONG block,char* item);

void	mem_free(void** ptr_addr);

int		memcheck(char *array,int test,int num);

void	SwapBytesInWords( short *loc, int words );

int		refill_buffer(Bit_stream_struc *bs);


#ifndef USE_TABLES
extern FILE*	OpenTableFile(char* name);
#endif


#ifdef LAYER1
extern void		I_CRC_calc(frame_params*, UINT[2][SBLIMIT],UINT*);
#endif


#ifdef LAYER2
int		read_bit_alloc(int table,al_table* alloc);
int		pick_table(frame_params*);
void	II_CRC_calc(frame_params*, UINT[2][SBLIMIT],UINT[2][SBLIMIT], UINT*);
#endif


void putbits(Bit_stream_struc *bs,UINT val,INT N);
void byte_ali_putbits(Bit_stream_struc *bs,UINT val,INT N);


extern int            BitrateIndex(int, int, int);
extern int            SmpFrqIndex(long, int*);
extern void           double_to_extended(double*, char[10]);
extern void           extended_to_double(char[10], double*);
int		refill_buffer(Bit_stream_struc* bs);
void empty_buffer(Bit_stream_struc *bs,int minimum);
void           open_bit_stream_w(Bit_stream_struc*, char*, int);
void           open_bit_stream_r(Bit_stream_struc*, char*, int);
void close_bit_stream_r(Bit_stream_struc* bs);
void close_bit_stream_w(Bit_stream_struc* bs);

void	alloc_buffer(Bit_stream_struc* bs, int);
void	desalloc_buffer(Bit_stream_struc*);
void	back_track_buffer(Bit_stream_struc*, int);
UINT	get1bit(Bit_stream_struc*);
void	put1bit(Bit_stream_struc*, int);
ULONG	look_ahead(Bit_stream_struc*, int);
ULONG	getbits(Bit_stream_struc*, int);
ULONG	byte_ali_getbits(Bit_stream_struc*, int);
int		end_bs(Bit_stream_struc*);
int		seek_sync(Bit_stream_struc*, long, int);
void	update_CRC(UINT, UINT, UINT*);
UINT	hget1bit(); /* MI */
ULONG	hgetbits(int);
ULONG	hsstell();
void	hputbuf(UINT,int);
//extern enum byte_order DetermineByteOrder();
extern void SwapBytesInWords( short *loc, int words );


ULONG sstell(Bit_stream_struc *bs);


#endif
