#include "psy.h"
#include "encoder.h"
#include "subs.h"


#if defined(LAYER2)

//#define NEWFFT	 
//#define DYNALLOC

/**********************************************************************
 * ISO MPEG Audio Subgroup Software Simulation Group (1996)
 * ISO 13818-3 MPEG-2 Audio Encoder - Lower Sampling Frequency Extension
 *
 * $Id: psy.cpp,v 1.1.1.1 1999/12/05 21:15:52 afaber Exp $
 *
 * $Log: psy.cpp,v $
 * Revision 1.1.1.1  1999/12/05 21:15:52  afaber
 * no message
 *
 * Revision 1.2  1998/10/05 17:06:48  larsi
 * *** empty log message ***
 *
 * Revision 1.1.1.1  1998/10/05 14:47:18  larsi
 *
 * Revision 1.1  1996/02/14 04:04:23  rowlands
 * Initial revision
 *
 * Received from Mike Coleman
 **********************************************************************/
#include "common.h"

#ifdef LAYER2
//FILE		*fpo;	/* file pointer */

void psycho_anal(	SHORT*	buffer,
					SHORT	savebuf[1056],
					INT		chn,
					INT		lay,
					FLOAT	snr32[32],
					DOUBLE	sfreq)
{
 unsigned int   i, j, k;
 FLOAT          r_prime, phi_prime;
 FLOAT          freq_mult, bval_lo, minthres, sum_energy;
 double         tb, temp1, temp2, temp3;

/* The static variables "r", "phi_sav", "nNew", "old" and "oldest" have    */
/* to be remembered for the unpredictability measure.  For "r" and        */
/* "phi_sav", the first index from the left is the channel select and     */
/* the second index is the "age" of the data.                             */

 static int     nNew = 0, old = 1, oldest = 0;
 static int     init = 0, flush, sync_flush, syncsize, sfreq_idx;

/* The following static variables are constants.                           */

 static double  nmt = 5.5;

#define ORGTABLE
#ifdef ORGTABLE
 static FLOAT   crit_band[27] = {0,  100,  200, 300, 400, 510, 630,  770,
                               920, 1080, 1270,1480,1720,2000,2320, 2700,
                              3150, 3700, 4400,5300,6400,7700,9500,12000,
                             15500,25000,30000};

 static FLOAT   bmax[27] = {20.0F, 20.0F, 20.0F, 20.0F, 20.0F, 17.0F, 15.0F,
                            10.0F,  7.0F,  4.4F,  4.5F,  4.5F,  4.5F,  4.5F,
                             4.5F,  4.5F,  4.5F,  4.5F,  4.5F,  4.5F,  4.5F,
                             4.5F,  4.5F,  4.5F,  3.5F,  3.5F,  3.5F};

#else
 static FLOAT   crit_band[27] = {0,  43,  86, 129, 215, 510, 630,  770,
                               920, 1080, 1270,1480,1720,2000,2320, 2700,
                              3150, 3700, 4400,5300,6400,7700,9500,12000,
                             15500,25000,30000};

 static FLOAT   bmax[27] = {20.0F, 20.0F, 20.0F, 20.0F, 20.0F, 17.0F, 15.0F,
                            10.0F,  7.0F,  4.4F,  4.5F,  4.5F,  4.5F,  4.5F,
                             4.5F,  4.5F,  4.5F,  4.5F,  4.5F,  4.5F,  4.5F,
                             4.5F,  4.5F,  4.5F,  3.5F,  3.5F,  3.5F};

#endif

 static int nSpreadNotZero=0;
static int SpreadNotZero[200];

/* The following pointer variables point to large areas of memory         */
/* dynamically allocated by the mem_alloc() function.  Dynamic memory     */
/* allocation is used in order to avoid stack frame or data area          */
/* overflow errors that otherwise would have occurred at compile time     */
/* on the Macintosh computer.                                             */

	static float	grouped_c[CBANDS];
	static float	grouped_e[CBANDS];
	static float	nb[CBANDS];
	static float	cb[CBANDS];
	static float	ecb[CBANDS];
	static float	bc[CBANDS];

	static float	wsamp_r[BLKSIZE];
	static float	phi[BLKSIZE];
	static float	energy[BLKSIZE];
	static float	c[HBLKSIZE];
	static float	fthr[HBLKSIZE];
	static float	snrtmp[2][32];

 static int     *numlines;
 static int     *partition;
 static FLOAT   *cbval, *rnorm;
 static FLOAT   *window;
 static FLOAT   *absthr;
 static double  *tmn;
 static FCB     *SpreadFunc;
 static FHBLK   *lthr;
 static F2HBLK  *r;
#ifdef NEWFFT
    static float	x_sav[2][2][HBLKSIZE];
	static float	y_sav[2][2][HBLKSIZE];
#else
	static F2HBLK	*phi_sav;
#endif

/* These dynamic memory allocations simulate "automatic" variables        */
/* placed on the stack.  For each mem_alloc() call here, there must be    */
/* a corresponding mem_free() call at the end of this function.           */


 if(init==0)
 {
/* These dynamic memory allocations simulate "static" variables placed    */
/* in the data space.  Each mem_alloc() call here occurs only once at     */
/* initialization time.  The mem_free() function must not be called.      */

     numlines = (int *) mem_alloc(sizeof(ICB), "numlines");
     partition = (int *) mem_alloc(sizeof(IHBLK), "partition");
//     fpo = fopen("out.dat", "wb");
//	if(fpo==NULL) {
//		MPegError("The attempt to open the output file failed");
//	}
     cbval = (FLOAT *) mem_alloc(sizeof(FCB), "cbval");
     rnorm = (FLOAT *) mem_alloc(sizeof(FCB), "rnorm");
     window = (FLOAT *) mem_alloc(sizeof(FBLK), "window");
     absthr = (FLOAT *) mem_alloc(sizeof(FHBLK), "absthr");
     tmn = (double *) mem_alloc(sizeof(MYDCB), "tmn");
     SpreadFunc = (FCB *) mem_alloc(sizeof(FCBCB), "SpreadFunc");
     lthr = (FHBLK *) mem_alloc(sizeof(F2HBLK), "lthr");
     r = (F2HBLK *) mem_alloc(sizeof(F22HBLK), "r");
#ifndef NEWFFT
     phi_sav = (F2HBLK *) mem_alloc(sizeof(F22HBLK), "phi_sav");
#endif

     i = (int)(sfreq + 0.5);
     switch(i){
        case 32000: sfreq_idx = 0; break;
        case 44100: sfreq_idx = 1; break;
        case 48000: sfreq_idx = 2; break;
        default:    
			MPegError("error, invalid sampling frequency: Hz\n");
     }
//     printf("absthr[][] sampling frequency index: %d\n",sfreq_idx);
     read_absthr(absthr, sfreq_idx);
     if(lay==1){
        flush = 384;
        syncsize = 1024;
        sync_flush = 576;
     }
     else {
        flush = (int)(384*3.0/2.0);
        syncsize = 1056;
        sync_flush = syncsize - flush;
     }
/* calculate HANN window coefficients */
/*   for(i=0;i<BLKSIZE;i++)window[i]=0.5*(1-cos(2.0*PI*i/(BLKSIZE-1.0))); */
     for(i=0;i<BLKSIZE;i++)
		 window[i]=(float)(0.5*(1-cos(2.0*PI*(i-0.5)/BLKSIZE)));
/* reset states used in unpredictability measure */
     for(i=0;i<HBLKSIZE;i++){
        r[0][0][i]=r[1][0][i]=r[0][1][i]=r[1][1][i]=0;
        lthr[0][i] = 60802371420160.0;
        lthr[1][i] = 60802371420160.0;

#ifdef NEWFFT
	x_sav[0][0][i]=x_sav[1][0][i]=0;
	x_sav[0][1][i]=x_sav[1][1][i]=0;
	y_sav[0][0][i]=y_sav[1][0][i]=0;
	y_sav[0][1][i]=y_sav[1][1][i]=0;
#else
    phi_sav[0][0][i]=phi_sav[1][0][i]=0;
    phi_sav[0][1][i]=phi_sav[1][1][i]=0;
#endif

     }
/*****************************************************************************
 * Initialization: Compute the following constants for use later             *
 *    partition[HBLKSIZE] = the partition number associated with each        *
 *                          frequency line                                   *
 *    cbval[CBANDS]       = the center (average) bark value of each          *
 *                          partition                                        *
 *    numlines[CBANDS]    = the number of frequency lines in each partition  *
 *    tmn[CBANDS]         = tone masking noise                               *
 *****************************************************************************/
/* compute fft frequency multiplicand */
     freq_mult = (float)sfreq/BLKSIZE;
 
/* calculate fft frequency, then bval of each line (use fthr[] as tmp storage)*/
     for(i=0;i<HBLKSIZE;i++){
        temp1 = i*freq_mult;
        j = 1;
        while(temp1>crit_band[j])j++;
        fthr[i]=(float)(j-1+(temp1-crit_band[j-1])/(crit_band[j]-crit_band[j-1]));
     }
     partition[0] = 0;
/* temp2 is the counter of the number of frequency lines in each partition */
     temp2 = 1;
     cbval[0]=fthr[0];
     bval_lo=fthr[0];

     for(i=1;i<HBLKSIZE;i++){
        if((fthr[i]-bval_lo)>0.33)
		{
           partition[i]=partition[i-1]+1;
           cbval[partition[i-1]] = (float)(cbval[partition[i-1]]/temp2);
           cbval[partition[i]] = fthr[i];
           bval_lo = fthr[i];
           numlines[partition[i-1]] = (int)temp2;
           temp2 = 1;
        }
        else {
           partition[i]=partition[i-1];
           cbval[partition[i]] += fthr[i];
           temp2++;
        }
		//printf ("Partition[%3d]=%d\n",i,partition[i]);
     }
     numlines[partition[i-1]] = (int)temp2;
     cbval[partition[i-1]] = (float)(cbval[partition[i-1]]/temp2);
 
/************************************************************************
 * Now compute the spreading function, SpreadFunc[j][i], the value of the spread-*
 * ing function, centered at band j, for band i, store for later use    *
 ************************************************************************/

	nSpreadNotZero=0;		   
	 memset(SpreadNotZero,sizeof(SpreadNotZero)*sizeof(int),0x00);

     for(j=0;j<CBANDS;j++)
	 {
        for(i=0;i<CBANDS;i++)
		{
           temp1 = (cbval[i] - cbval[j])*1.05;
           if(temp1>=0.5 && temp1<=2.5){
              temp2 = temp1 - 0.5;
              temp2 = 8.0 * (temp2*temp2 - 2.0 * temp2);
           }
           else temp2 = 0;
           temp1 += 0.474;

           temp3 = 15.811389+7.5*temp1-17.5*sqrt((double) (1.0+temp1*temp1));
           if(temp3 <= -100) SpreadFunc[i][j] = 0;
           else 
		   {
			   nSpreadNotZero++;
              temp3 = (temp2 + temp3)*LN_TO_LOG10;
              SpreadFunc[i][j] = (float)exp(temp3);
           }
        }
     }

  /* Calculate Tone Masking Noise values */
	for(j=0;j<CBANDS;j++)
	{
		float* pfSpread=SpreadFunc[j];
		temp1 = 15.5 + cbval[j];
		tmn[j] = (temp1>24.5) ? temp1 : 24.5;
  /* Calculate normalization factors for the net spreading functions */
        temp1= 0;

        for(i=0;i<CBANDS;i++)
		{
           temp1 += *pfSpread++;
        }
		rnorm[j]=temp1;

     }
     init++;
 }
 
/************************* End of Initialization *****************************/
// switch(lay) 
 {
//	 assert(lay==1 || lay==2);
//  case 1:
//  case 2:
//	  i=0;
    for(i=0; i<(unsigned int)lay; i++)
	  {
/*****************************************************************************
 * Net offset is 480 samples (1056-576) for layer 2; this is because one must*
 * stagger input data by 256 samples to synchronize psychoacoustic model with*
 * filter bank outputs, then stagger so that center of 1024 FFT window lines *
 * up with center of 576 "nNew" audio samples.                                *
 *                                                                           *
 * For layer 1, the input data still needs to be staggered by 256 samples,   *
 * then it must be staggered again so that the 384 "nNew" samples are centered*
 * in the 1024 FFT window.  The net offset is then 576 and you need 448 "nNew"*
 * samples for each iteration to keep the 384 samples of interest centered   *
 *****************************************************************************/

        for(j=0; j<(unsigned int)syncsize; j++)
		{
           if(j<(sync_flush))savebuf[j] = savebuf[j+flush];
           else savebuf[j] = *buffer++;
           if(j<BLKSIZE)
		   {
/**window data with HANN window***********************************************/
              wsamp_r[j] = window[j]*((FLOAT) savebuf[j]);
           }
        }
/**Compute FFT****************************************************************/
		MP2RealFour1024(wsamp_r,energy,phi);

//        fft(wsamp_r,energy,phi,1024);
/*****************************************************************************
 * calculate the unpredictability measure, given energy[f] and phi[f]        *
 *****************************************************************************/
/*only update data "age" pointers after you are done with both channels      */
/*for layer 1 computations, for the layer 2 double computations, the pointers*/
/*are reset automatically on the second pass                                 */
         if(lay==2 || (lay==1 && chn==0) ){
           if(nNew==0){nNew = 1; oldest = 1;}
           else {nNew = 0; oldest = 0;}
           if(old==0)old = 1; else old = 0;
        }
        for(j=0; j<HBLKSIZE; j++)
#ifndef NEWFFT
		{
//		   static double dCos,dSin;
//		   static float dHeap;
           r_prime = 2.0 * r[chn][old][j] - r[chn][oldest][j];
           phi_prime = 2.0 * phi_sav[chn][old][j] - phi_sav[chn][oldest][j];
           r[chn][nNew][j] = (float)sqrt((double) energy[j]);
           phi_sav[chn][nNew][j] = phi[j];


//			dHeap=(float)sqrt((float)(wsamp_r[2*j]*wsamp_r[2*j] + wsamp_r[2*j+1]*wsamp_r[2*j+1]));
//			dCos=r[chn][nNew][j] * cos((double) phi[j]);
//			dSin=r[chn][nNew][j] * sin((double) phi[j]);


//temp1=r[chn][nNew][j] * dCos - r_prime * cos((double) phi_prime);
//temp2=r[chn][nNew][j] * dSin - r_prime * sin((double) phi_prime);
//temp1=r[chn][nNew][j] * cos((double) phi[j]) - r_prime * cos((double) phi_prime);
//temp2=r[chn][nNew][j] * sin((double) phi[j]) - r_prime * sin((double) phi_prime);

temp1=wsamp_r[2*j  ] - r_prime * cos((double) phi_prime);
temp2=-wsamp_r[2*j+1] - r_prime * sin((double) phi_prime);

           temp3=r[chn][nNew][j] + fabs((double)r_prime);
           if(temp3 != 0)
			   c[j]=(float)sqrt(temp1*temp1+temp2*temp2)/temp3;
           else c[j] = 0;
        }
#else
		{

			double m1, m2, m3;

			r_prime   = 2.0 * r[chn][old][j] - r[chn][oldest][j];

			m3 = r_prime/(r[chn][old][j]*r[chn][old][j]*r[chn][oldest][j]);

			m1 = x_sav[chn][old][j]*x_sav[chn][old][j]-y_sav[chn][old][j]*y_sav[chn][old][j];

			m1 *= m3;
			m2 = 2.0*(x_sav[chn][old][j]*y_sav[chn][old][j]);
			m2 *= m3;

			temp1 = wsamp_r[j]-( m1*x_sav[chn][oldest][j]+m2*y_sav[chn][oldest][j]);
			temp2 = wsamp_i[j]-(-m1*y_sav[chn][oldest][j]+m2*x_sav[chn][oldest][j]);

			r[chn][nNew][j] = sqrt((double) energy[j]);

			temp3 = r[chn][nNew][j] + fabs(r_prime);
	    
			if ( temp3 != 0.0 ) c[j] = sqrt( temp1*temp1+temp2*temp2 ) / temp3;
			else                c[j] = 0;
		}

		memcpy( &x_sav[chn][nNew][0], wsamp_r, HBLKSIZE * sizeof(float) );
		memcpy( &y_sav[chn][nNew][0], wsamp_i, HBLKSIZE * sizeof(float) );
#endif

/*****************************************************************************
 * Calculate the grouped, energy-weighted, unpredictability measure,         *
 * grouped_c[], and the grouped energy. grouped_e[]                          *
 *****************************************************************************/
        for(j=1;j<CBANDS;j++){
           grouped_e[j] = 0;
           grouped_c[j] = 0;
        }
        grouped_e[0] = energy[0];
        grouped_c[0] = energy[0]*c[0];

        for(j=1;j<HBLKSIZE;j++){
           grouped_e[partition[j]] += energy[j];
           grouped_c[partition[j]] += energy[j]*c[j];
        }

/*****************************************************************************
 * convolve the grouped energy-weighted unpredictability measure             *
 * and the grouped energy with the spreading function, SpreadFunc[j][k]      *
 *****************************************************************************/
        for(j=0;j<CBANDS;j++)
		{
			float* pfSpread=SpreadFunc[j];
			float fSumEcb=0;
			float fSumCb=0;

			for(k=0;k<CBANDS;k++)
			{
				float temp=*pfSpread++;
				if(temp != 0.0)
				{
					fSumEcb += temp*grouped_e[k];
					fSumCb += temp*grouped_c[k];
				}
			}


			if(fSumEcb !=0)
			{
			   ecb[j]=fSumEcb;
			   cb[j] = fSumCb/fSumEcb;
			}
			else 
			{
				ecb[j]= 0;
				cb[j] = 0;
			}
        }

/*****************************************************************************
 * Calculate the required SNR for each of the frequency partitions           *
 *         this whole section can be accomplished by a table lookup          *
 *****************************************************************************/
        for(j=0;j<CBANDS;j++)
		{
           if(cb[j]<.05)cb[j]=0.05F;
           else if(cb[j]>.5)cb[j]=0.5;

           tb = -0.434294482*log((double) cb[j])-0.301029996;
		
		   cb[j]=tb;
           bc[j] = tmn[j]*tb + nmt*(1.0-tb);
           k = cbval[j] + 0.5;
           bc[j] = (bc[j] > bmax[k]) ? bc[j] : bmax[k];
           bc[j] = exp((double) -bc[j]*LN_TO_LOG10);
        }

/*****************************************************************************
 * Calculate the permissible noise energy level in each of the frequency     *
 * partitions. Include absolute threshold and pre-echo controls              *
 *         this whole section can be accomplished by a table lookup          *
 *****************************************************************************/
        for(j=0;j<CBANDS;j++)
           if(rnorm[j] && numlines[j])
              nb[j] = ecb[j]*bc[j]/(rnorm[j]*numlines[j]);
           else nb[j] = 0;

        for(j=0;j<HBLKSIZE;j++){
/*temp1 is the preliminary threshold */
           temp1=nb[partition[j]];
           temp1=(temp1>absthr[j])?temp1:absthr[j];
/*do not use pre-echo control for layer 2 because it may do bad things to the*/
/*  MUSICAM bit allocation algorithm                                         */
           if(lay==1){
              fthr[j] = (temp1 < lthr[chn][j]) ? temp1 : lthr[chn][j];
              temp2 = temp1 * 0.00316;
              fthr[j] = (temp2 > fthr[j]) ? temp2 : fthr[j];
           }
           else fthr[j] = temp1;
           lthr[chn][j] = (float)(LXMIN*temp1);
        }

/*****************************************************************************
 * Translate the 512 threshold values to the 32 filter bands of the coder    *
 *****************************************************************************/
        for(j=0;j<193;j += 16)
		{
           minthres = 60802371420160.0;
           sum_energy = 0.0;
           for(k=0;k<17;k++){
              if(minthres>fthr[j+k])minthres = fthr[j+k];
              sum_energy += energy[j+k];
           }
           snrtmp[i][j/16] = (float)(4.342944819 * log(sum_energy/(minthres * 17.0)));
        }
        for(j=208;j<(HBLKSIZE-1);j += 16)
		{
           minthres = 0.0;
           sum_energy = 0.0;
           for(k=0;k<17;k++){
              minthres += fthr[j+k];
              sum_energy += energy[j+k];
           }
           snrtmp[i][j/16] = (float)(4.342944819 * log(sum_energy/minthres));
        }
/*****************************************************************************
 * End of Psychoacuostic calculation loop                                    *
 *****************************************************************************/
     }
     for(i=0; i<32; i++)
	 {
        if(lay==2)
		{
//			if (fabs(snrtmp[0][i]-snrtmp[1][i])>0.0001)
//			{
//				printf("Different\n");
//			}
//           snr32[i]=snrtmp[0][i];
           snr32[i]=(snrtmp[0][i]>snrtmp[1][i])?snrtmp[0][i]:snrtmp[1][i];
//           snr32[i]=max(snrtmp[0][i],snrtmp[1][i]);
		}
        else snr32[i]=snrtmp[0][i];
     }
//  default:
//     printf("error, invalid MPEG/audio coding layer: %d\n",lay);
 }

/* These mem_free() calls must correspond with the mem_alloc() calls     */
/* used at the beginning of this function to simulate "automatic"        */
/* variables placed on the stack.                                        */

}
#endif

#endif


/******************************************************************************
routine to read in absthr table from a file.
******************************************************************************/


void read_absthr(FLOAT* absthr,int table)
{
	float *a;
	int j;
  
	switch(table)
	{
		case 0: a = absthr_0; break;
		case 1: a = absthr_1; break;
		case 2: a = absthr_2; break;
		default: MPegError("absthr table: Not valid table number\n");
	}

	for (j=0; j<HBLKSIZE; j++)
	{
		absthr[j] =  a[j];
	}
}
